package eu.hsrw.ias.ggd;

import java.util.LinkedList;
import java.util.List;

public class Device {
    private String id;
    private List<SensorData> data;

    public Device(String identifier) {
        this.id = identifier;
        this.data = new LinkedList<SensorData>();
    }

    public void addSensorData(SensorData d) {
        this.data.add(d);
    }

    public List<SensorData> getSensorData() {
        return data;
    }

    public String getId() {
        return id;
    }

    public Boolean hasTag(String tag) {
        for (SensorData sensorData : data) {
            if (sensorData.getTag() == tag) return true;
        }
        return false;
    }

    public SensorData getSensorDataByTag(String tag) {
        for (SensorData sd : data) {
            if (sd.getTag() == tag) return sd;
        }
        return null;
    }

    public SensorData getSensorDataById(String id) {
        for (SensorData sd : data) {
            if (sd.getSensorId() == id) return sd;
        }
        return null;
    }

    public String toString() {
        String str = "Device: '"+ id +"', data: [";

        for(SensorData sd: data) {
            str += "SensorData(id: '"+ sd.getSensorId() +"',";
            str += " tag: '"+ sd.getTag() +"',";
            str += " value: "+ sd.getValue() +")";
        }

        return str + "]";
    }
}
